import random
import string
import time
import matplotlib.pyplot as plt
from statistics import mean

points = list(range(10, 40))
fct_points = lambda e:50*e**2
repetition = 80
resultats = []

def decoupe(s, i, j):
	""" retourne la chaîne entre les positions i et j de s """
	resultat = ""
	for k in range(i, j):
		resultat += s[k]
	return resultat

def decoupe2(s, i, j):
	return s[i:j]


resultats1 = []
resultats2 = []

for i in points:
	print(i, end="\r")
	i = fct_points(i)
	s = "#"*i 
	temps_calculs1 = []
	resultats1.append(temps_calculs1)
	temps_calculs2 = []
	resultats2.append(temps_calculs2)
	for _ in range(repetition):
		init_time = time.time_ns()
		_ = decoupe(s, 1, i-5) 
		stop_time = time.time_ns()
		temps_calculs1.append(stop_time - init_time)
		init_time = time.time_ns()
		_ = decoupe2(s, 1, i-5)
		stop_time = time.time_ns()
		temps_calculs2.append(stop_time - init_time)

plt.xlabel("Taille de la chaîne")
plt.title("Temps d'exécution de la fonction decoupe par rapport à la version Python")
ax1 = plt.subplot(121)
ax1.plot(
	list(map(fct_points, points)),
	[mean(x)/10**3 for x in  resultats1],
	marker=".",
	label="decoupe"
	)
ax1.set_ylabel("Temps (en µs)")
ax1.set_xlabel("Taille de la chaine")
plt.legend()
ax2 = plt.subplot(122)
ax2.plot(
	list(map(fct_points, points)),
	[mean(x)/10**3 for x in  resultats2],
	marker=".",
	label="Version python",
	color = 'tab:red'
	)

ax2.set_ylabel("Temps (en µs)")
ax2.set_xlabel("Taille de la chaâine")
ax2.yaxis.set_ticks_position("right")
ax2.yaxis.set_label_position("right")
plt.legend()
plt.savefig("decoupe.png")
